//
//  Tache.swift
//  Post'TIM version swift
//
//  Créé par Alain Boudreault le 20105.11.15
//  Copyright (c) 2014 Alain Boudreault. All rights reserved.
//
//  MARK: - Note importante!
//  ============================================================================================
//  À l'usage exclusif des étudiants et étudiantes de
//  Techniques d'Intégration Multimédia
//  du cégep de Saint-Jérôme.
//  --------------------------------------------------------------------------------------------
//  Il est interdit de reproduire, en tout ou en partie, à des fins commerciales,
//  le code source, les scènes, les éléments graphiques, les classes et
//  tout autre contenu du présent projet sans l’autorisation écrite de l'auteur.
//
//  Pour obtenir l’autorisation de reproduire ou d’utiliser, en tout ou en partie,
//  le présent projet, veuillez communiquer avec:
//
//  Alain Boudreault, aboudrea@cstj.qc.ca
//
//  ============================================================================================

/*
    /// Voici les mots clés valides pour la documentation en ligne sous Objective-C
    /// Probablement disponible sous peu sous swift
    Ceci est une description de l'objet courant ...

    :brief: Ceci est la description sommaire
    :attention: À l'usage exclusif des étudiants de TIM
    :author: Alain Boudreault
    :bug: La méthode @b mangerDuPain retourne un lapin!
    :copyright: 2014 - Alain Boudreault
    :date: 2014.10.27
    :invariant: ..
    :note: ..
    :post: ..
    :pre: ..
    :remarks: Voici des remarques ...
    :sa: sa text
    :see: see text
    :since: depuis toujours
    :todo: Corriger la méthode @b mangerDuPain
    :version: 1.0
    :warning: Ici la voix des mistérons...
    :result: result text
    :return: return text
    :returns: returns text

    :code:
    // code text
    while someCondition {
        NSLog("Hello")
        doSomething()
    }
    :endcode:

    Dernière ligne de la description.

*/


import Foundation

// Note: un retour de chariot est requis entre les différentes sections de la documentation.

/**
    Classe pour regrouper les informations d'une tâche. 

    Propose un init permettant de construire une tâche à partir d'un NSDictionary

    :returns: une instance de la classe Tache.

    :param: aucun

    Auteur:   Alain Boudreault

    Date:     2014.10.20
*/
class Tache {

    /// La date de la tâche.
    var date:NSDate
    /// Le nom de la tâche.
    var tache:String
    /// L'importance de la tâche, une valeur entre 1...9
    var importance:String
    /// Un texte décrivant la tâche.
    var description:String  ///< Un texte décrivant la tâche.  // Syntaxe non fonctionnelle sous Swift.

    /**
        Construire une tache vide.
        :param: aucun
    */
    init () {
        self.date           = NSDate()
        self.description    = ""
        self.importance     = ""
        self.tache          = ""
    } // init

    /**
        Construire une tache à partir de données d'un dictionnaire.
    
        :param: detail:NSDictionary contenant les clés "date", "description", "importance" et "tache"
    */
    init (detail:NSDictionary) {
        self.date           = detail["date"]        as NSDate
        self.description    = detail["description"] as String
        // FIXME: Valider le contenu de detail["importance"]
        self.importance     = detail["importance"]  as String
        self.tache          = detail["tache"]       as String
    } // init

    /**
        Transformer les propriétés de la classe Tache en format NSDictionary

        :returns: Tache en format NSDictionary

        Auteur:   Alain Boudreault
    
        Date:       2014.10.20
    
        M-A-J:      2014.10.21 - Ajout de la documentation en ligne.
    
    */
    func tacheToDictionary() -> NSDictionary {
        return NSDictionary(dictionary: ["tache":self.tache,
            "date":self.date,
            "importance":self.importance,
            "description":self.description])
    } // tacheToDictionary()

    //TODO: Ajouter une méthode quiSuisJe()
    
} // class Tache