//
//  VCNotes.swift
//  Post'TIM version swift
//
//  Créé par Alain Boudreault le 20105.11.15
//  Copyright (c) 2014 Alain Boudreault. All rights reserved.
//
//  MARK: - Note importante!
//  ============================================================================================
//  À l'usage exclusif des étudiants et étudiantes de
//  Techniques d'Intégration Multimédia
//  du cégep de Saint-Jérôme.
//  --------------------------------------------------------------------------------------------
//  Il est interdit de reproduire, en tout ou en partie, à des fins commerciales,
//  le code source, les scènes, les éléments graphiques, les classes et
//  tout autre contenu du présent projet sans l’autorisation écrite de l'auteur.
//
//  Pour obtenir l’autorisation de reproduire ou d’utiliser, en tout ou en partie,
//  le présent projet, veuillez communiquer avec:
//
//  Alain Boudreault, aboudrea@cstj.qc.ca
//
//  ============================================================================================

import UIKit

// *********************************************************************************
// Effacer le commentaire
// TODO: - ETAPE 3.3 -  Indiquer que la classe courante est abonnée au protocole
//                          'VCAjouterTache' ->  '<tacheDelegate>'
// ---------------------------------------------------------------------------------
class VCNotes: UIViewController, UITableViewDataSource /*, tacheDelegate */{
    @IBOutlet weak var tableView: UITableView!

    var tableauDesTaches = NSMutableArray() //  = [NSDictionary]()
    var indiceTacheCourante = 0

    
    /**
    Description
    */
    override func viewDidLoad() {
        super.viewDidLoad()
        tableView.dataSource = self
        // Au besoin, copier la liste des tâches vers le dossier 'Documents'.
        copierPlistVersDocuments()
        // Lire la liste des tâches à partir du dossier 'Documents'.
        lirePlist()
        println(tableauDesTaches)
    } // viewDidLoad()

    
    /**
    Description
    */
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    } // didReceiveMemoryWarning()


    // MARK: - Gestion de la listeDesTaches.plist
    /**
        Envoyer une copie du ficher 'listeDesTaches.plist' vers le dossier 'Document'.
        Raison: La version livrée avec l'app est non modifiable.
    */
     func copierPlistVersDocuments() {
        let filemanager = NSFileManager.defaultManager()
        let documentsPath: AnyObject = NSSearchPathForDirectoriesInDomains(.DocumentDirectory,.UserDomainMask,true)[0]
        let destinationPath = documentsPath.stringByAppendingString("/listeDesTaches.plist")

        if !filemanager.fileExistsAtPath(destinationPath) {
            
            let fileForCopy = NSBundle.mainBundle().pathForResource("listeDesTaches",ofType:"plist")
            filemanager.copyItemAtPath(fileForCopy!,toPath:destinationPath, error: nil)
            println("La liste des tâches a été copiée dans le dossier 'mes documents'")
        }
        else{
            println("La liste des tâches est déjà dans le dossier 'mes documents'")
        }
     } // copierPlistVersDocuments

    
    /**
    Lire le fichier 'listeDesTaches.plist' vers le tableau 'tableauDesTaches'
    */
    func lirePlist() {
        let filemanager = NSFileManager.defaultManager()
        let documentsPath : AnyObject = NSSearchPathForDirectoriesInDomains(.DocumentDirectory,.UserDomainMask,true)[0]
        let destinationPath = documentsPath.stringByAppendingString("/listeDesTaches.plist")
        tableauDesTaches = NSMutableArray(contentsOfFile: destinationPath)
        NSLog("%@", tableauDesTaches);
    } // lirePlist()

    /** 
        Écrire le tableau 'tableauDesTaches' dans le fichier 'listeDesTaches.plist'
    */
    func updatePlist() {
        let filemanager = NSFileManager.defaultManager()
        let documentsPath : AnyObject = NSSearchPathForDirectoriesInDomains(.DocumentDirectory,.UserDomainMask,true)[0]
        let destinationPath = documentsPath.stringByAppendingString("/listeDesTaches.plist")
        
        tableauDesTaches.writeToFile(destinationPath, atomically:true)
    }  // updatePlist()
    
    
    // MARK: - Méthodes du protocole UITableViewDataSource
    
    /**
    Description
    */
    func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return tableauDesTaches.count
    }  // tableView.numberOfRowsInSection

    /**
    Description
    */
    func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCellWithIdentifier("Cell", forIndexPath: indexPath) as CelluleTache
        println(tableauDesTaches[indexPath.row]["tache"]!)
        // Présenter le nom de la tâche
        cell.tache.text = tableauDesTaches[indexPath.row]["tache"]! as NSString

        // Utilisation d'un 'DateFormatter' pour convertir en heure locale...
        // Voir documentation: // http://userguide.icu-project.org/formatparse/datetime
        // *********************************************************************************
        // À compléter
        // TODO: - Action 1.3 - Ajouter un NSDateFormatter pour convertir une date en format local.
        // ---------------------------------------------------------------------------------
        /// Insérer le code ici.

        
        // ---------------------------------------------------------------------------------
        
        // Présenter le niveau d'importance de la tâche
        cell.importance.text = tableauDesTaches[indexPath.row]["importance"]! as NSString
        return cell
    }  // tableView.cellForRowAtIndexPath

    // *********************************************************************************
    // À compléter
    // TODO: - Action 1.2 -  Ajouter la méthode 'commitEditingStyle'
    //       Actualiser le tableau des tâches
    //       Actualiser le UITableView
    //       Enregistrer le tableau des tâches dans 'listeDesTaches.plist'
    // ---------------------------------------------------------------------------------
    // Méthode de délégation pour gérer la suppression de la cellule sur swap
    // Note: Il suffit d'ajouter cette méthode au projet pour qu'il soit possible 
    // d'effacer une cellule d'un TV sur un simple glissement vers la gauche.
    // #################################################################################

    /// Insérer le code ici.

    
    // ---------------------------------------------------------------------------------
    
    // MARK: - Navigation Segue
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {

        // *********************************************************************************
        // À compléter
        // TODO: - Action 1.4 - Déterminer la cellule qui a initié le segue.
        // ---------------------------------------------------------------------------------
        // Note sender == UIButton et non pas UITableViewCell
        // Donc, voici comment obtenir la position du UITableViewCell:
        /// Ajouter le code ici:

        
        // ---------------------------------------------------------------------------------
        
        // *********************************************************************************
        // À compléter
        // TODO: - Action 1.5   -  Ajouter le code pour déterminer la destination du segue.
        //                      -  Préparer les données en fn de la destination
        // ---------------------------------------------------------------------------------
        /// Ajouter le code ici:

        
        
        // ---------------------------------------------------------------------------------
        
    }  // prepareForSegue

    //MARK: - ETAPE 3.4 - Programmer les méthodes du protocole tacheDelegate
    // *********************************************************************************
    // À compléter
    // ETAPE 3.4a - Ajouter la méthode de protocole 'ajouterTache'
    // ---------------------------------------------------------------------------------
    /// Insérer le code ici:

    
    // ---------------------------------------------------------------------------------
    
    // *********************************************************************************
    // À compléter
    // ETAPE 3.5a - Ajouter la méthode de protocole 'ModifierTache'
    // ---------------------------------------------------------------------------------
    /// Insérer le code ici:

    
    // ---------------------------------------------------------------------------------
    
} // class VCNotes
